=== debian/changelog ===
mame (0.242+dfsg.1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

  [ Jordi Mallach ]
  * Add debian/gbp.conf with our current gbp defaults.

 -- Jordi Mallach <jordi@debian.org>  Sat, 09 Apr 2022 00:01:51 +0200

mame (0.241+dfsg.1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

 -- Jordi Mallach <jordi@debian.org>  Mon, 28 Feb 2022 11:45:08 +0100
