=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg$//,repacksuffix=+dfsg.1,repack,compression=xz" \
    https://github.com/mamedev/mame/tags/ \
        .+@PACKAGE@(\d)(\d{3})\.tar\.gz
