## mame 0.244+dfsg.1

=== debian/changelog ===
mame (0.244+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh existing patches.
  * New patch ftbfs_244_netlist_plib (missing defs).

 -- Cesare Falco <c.falco@ubuntu.com>  Wed, 25 May 2022 19:25:40 +0200

mame (0.243+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Cesare Falco <c.falco@ubuntu.com>  Fri, 29 Apr 2022 15:10:37 +0200
