## mame 0.245+dfsg.1

=== debian/changelog ===
mame (0.245+dfsg.1-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 20 Jul 2022 14:06:43 -0700

mame (0.245+dfsg.1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

  [ Jordi Mallach ]
  * Refresh patches.

 -- Jordi Mallach <jordi@debian.org>  Thu, 30 Jun 2022 10:49:06 +0200
