=== debian/rules ===
--- 
+++ 
@@ -290,3 +290,6 @@
 	find debian/mame-data/usr/share/games/mame/language -type f -name "*.po" -delete
 	find debian/mame-data/usr/share/games/mame/language -type f -execdir chmod 644 {} \;
 	find debian/mame-data/usr/share/games/mame/plugins -type f -execdir chmod 644 {} \;
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
