## mame 0.246+dfsg.1

=== debian/changelog ===
mame (0.246+dfsg.1-0.1~mx21+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 01 Aug 2022 14:44:50 -0700
