## mame 0.247%2Bdfsg.1

=== debian/changelog ===
mame (0.247+dfsg.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Boyuan Yang <byang@debian.org>  Mon, 26 Sep 2022 16:41:30 -0400

mame (0.247+dfsg.1-1) unstable; urgency=medium

  * New upstream release.

 -- Cesare Falco <c.falco@ubuntu.com>  Wed, 31 Aug 2022 15:06:26 +0200

mame (0.246+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Cesare Falco <c.falco@ubuntu.com>  Sun, 31 Jul 2022 12:36:55 +0200
