## mame 0.247+dfsg.1

=== debian/changelog ===
mame (0.247+dfsg.1-1~mx19+1) mx; urgency=medium

  * New upstream release.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 31 Aug 2022 15:45:56 -0700
