=== debian/rules ===
--- 
+++ 
@@ -291,5 +291,6 @@
 	find debian/mame-data/usr/share/games/mame/language -type f -execdir chmod 644 {} \;
 	find debian/mame-data/usr/share/games/mame/plugins -type f -execdir chmod 644 {} \;
 
+# No dbgsym package:
 override_dh_strip:
 	dh_strip --no-automatic-dbgsym
