## mame 0.248+dfsg.1

=== debian/changelog ===
mame (0.248+dfsg.1-1) unstable; urgency=medium

  [ Cesare Falco ]
  * New upstream release.

  [ Jordi Mallach ]
  * Update Standards-Version to 4.6.1, with no changes.

 -- Jordi Mallach <jordi@debian.org>  Mon, 24 Oct 2022 01:58:59 +0200
